#include <stdio.h>
#include <string.h>
#include <wikisabl.h>

// Ki akarunk irni egy ekezetes szoveget H betu szelessegben, V betut meghagyva az elejen, azaz %H.Vs formaban.
// Annyival tobb byte-ot kell kiirni, ahannyal tobb byte-ot foglal az elso V betu V-nel. Vagyis igy:
// x = utf8byte(szoveg,V); printf("%-*.*s",H+x,V+x,szoveg);
static int utf8byte(const char *str,int betu)
{	// "betu" darab betut akarok str-bol kiirni. Hany byte-tal tobbet irjak ki?
int b, c, byte;

b = byte = 0;
while(*str && ( (c = *str++ & 0xC0) == 0x80 || b < betu) )
	{
	//printf("        b=%d, c=%x, byte=%d\n",b,c,byte);
	if(c == 0x80)
		byte++;	// utf8 2., 3. vagy 4. byte-ja, de printf azt hiszi, kulon betu
	else	b++;	// betuszam. Nem ekezetes, vagy az ekezetes utf8-kod elso byte-ja.
	}
return byte;
}


void sablfv(struct sablstr sabltomb, int debug)
{
int par,bszam;

if(debug >= 1)
	{
	printf("%s  %s\n",sabltomb.nev,hibahely(sabltomb.hivas));
	for(par=0; par < sabltomb.parszam; par++)
		{
		bszam = utf8byte(sabltomb.param[par].parnev,30) + 30;
		printf("\t%-*s %s\n",bszam,sabltomb.param[par].parnev,sabltomb.param[par].ertek);
		}
	}
else	{
	bszam = utf8byte(sabltomb.nev,45) + 45;
	printf("%-*.*s %3d    %-20s\n",bszam,bszam,sabltomb.nev,sabltomb.parszam,hibahely(sabltomb.hivas));
	}
}

#ifdef	DEBUG

#define	VAG	3	// hanyadik betunel vagjuk el a szoveget
int main()
{
static const char *probtomb[] = { "Fo", "Fő", "Szeptablazat", "Széptáblázat", "Franciaország" };
int i,hossz;

for(i=0; i < sizeof(probtomb)/sizeof(char *); i++)
	{
	hossz = utf8byte(probtomb[i],VAG);
	printf("%3d   |%-*.*s|\n",hossz,17+hossz,VAG+hossz,probtomb[i]);
	}
}

#endif
